# CILK_ROOT must contains the GCC/Cilk root directory
OS     	    = $(shell uname)
CPPFLAGS    = -DMAX_GENUS=$(MAX_GENUS) #-DNDEBUG
CXXFLAGS    = -std=c++11 -g -Wall -O3 # -fsanitize=thread # -Winline
CXX         = g++
TARGET_ARCH = -march=corei7 -mtune=corei7
TARGET 	    = wilf_alone_3

# Pour compiler avec une valeur différente: make MAX_GENUS=35
DEFAULT_MAX_GENUS=40
MAX_GENUS=$(DEFAULT_MAX_GENUS)

all: $(TARGET)

monoid.o: monoid.cpp monoid.hpp
treewalk.o: treewalk.cpp treewalk.hpp monoid.hpp
wilf_alone_3: treewalk.o monoid.o
	$(CXX) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

clean:
	rm -rf $(TARGET) *.o *~ 

test: all
	./treewalk

